/* NessusJ
 * Copyright (C) 1999 Alexis de Bernis <alexisb@cvs.nessus.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This program is a nessusd java client. For any information about
 * the nessus project visit <http://www.nessus.org>
 *
 *      PLEASE READ CAREFULLY NESSUS DOCUMENTATION BEFORE
 *                     USING THIS PROGRAM
 *
 */

/* importation directives has changed in newer JDK, uncomment
 * the ones you use if you have compilation troubles :
 * JDK up to 1.1.7 (Swing 1.0.x) : classes in com.sun.java.swing
 * JDK from 1.2 (Swing 1.1.x) : classes in javax.swing
 * You must change this in every .java file...
 */

import java.lang.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;

import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
//import javax.swing.*;
//import javax.swing.border.*;


class Family extends JPanel implements ActionListener
{
    private Hashtable children;
    private String name;
    private JCheckBox state;
    private JButton nameToClick;
	private NessusJ parent;
	private PicsLib pics;
	private NessusJUI gui;

    Family(String name,NessusJ parent)
    {
        super(new BorderLayout());

        this.name=name;
		this.parent=parent;
		pics=parent.get_pics_lib();
		gui=parent.get_gui();

        children=new Hashtable();
        state=new JCheckBox("",false);
        state.addActionListener(this);
        state.setActionCommand("state");
        state.setIcon(pics.get_pic("flag_red"));
        state.setSelectedIcon(pics.get_pic("flag_green"));
        nameToClick=new JButton(name);
        nameToClick.setBorder(new EmptyBorder(0,0,0,0));
        nameToClick.addActionListener(this);
        setBorder(new EtchedBorder());

        add("West",nameToClick);
        add("East",state);
    }

    public Hashtable getChildren()
    {
        return(children);
    }

    public void add_child(PlugIn child)
    {
		if(child.isActivated())
			state.setSelected(true);
        children.put(child.getName(),child);
    }

    public void actionPerformed(ActionEvent evt)
    {
        String command=evt.getActionCommand();

        if(command.equals("state"))
        {
            Enumeration temp=children.elements();

            while(temp.hasMoreElements())
                ((PlugIn) temp.nextElement()).setActivated(state.isSelected());
        }

        if(command.equals(name))
        {
            gui.refresh_plugin_list(this);
        }
    }

	public String get_family_name()
	{
		return(name);
	}
}
