/* NessusJ
 * Copyright (C) 1999 Alexis de Bernis <alexisb@cvs.nessus.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This program is a nessusd java client. For any information about
 * the nessus project visit <http://www.nessus.org>
 *
 *      PLEASE READ CAREFULLY NESSUS DOCUMENTATION BEFORE
 *                     USING THIS PROGRAM
 *
 */

import java.awt.*;
import java.util.Vector;



class HRule extends Panel
{
    int width,depth,Xmargin,Ymargin;


    HRule(int width,int depth,int Xmargin,int Ymargin)
    {
        super();

        this.width=width;
        this.depth=depth;
        this.Xmargin=Xmargin;
        this.Ymargin=Ymargin;
    
    }

    public void paint(Graphics g)
    {
        Color bg=getBackground();
        g.setColor(bg.darker());

        for(int i=0;i<depth;i++)
            g.drawLine(Xmargin,Ymargin+i,Xmargin+width,Ymargin+i);

        g.setColor(bg.brighter());

        for(int i=0;i<depth;i++)
            g.drawLine(Xmargin,i+depth+Ymargin,Xmargin+width,i+depth+Ymargin);
    }

    public Dimension getPreferredSize()
    {
        return(new Dimension(width+2*Xmargin,2*depth+2*Ymargin));
    }

    public Dimension getMinimumSize()
    {
        return(new Dimension(width+2*Xmargin,2*depth+2*Ymargin));
    }

    public Dimension getMaximumSize()
    {
        return(new Dimension(width+2*Xmargin,2*depth+2*Ymargin));
    }
}
