/* NessusJ
 * Copyright (C) 1999 Alexis de Bernis <alexisb@cvs.nessus.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This program is a nessusd java client. For any information about
 * the nessus project visit <http://www.nessus.org>
 *
 *      PLEASE READ CAREFULLY NESSUS DOCUMENTATION BEFORE
 *                     USING THIS PROGRAM
 *
 */

/* importation directives has changed in newer JDK, uncomment
 * the ones you use if you have compilation troubles :
 * JDK up to 1.1.7 (Swing 1.0.x) : classes in com.sun.java.swing
 * JDK from 1.2 (Swing 1.1.x) : classes in javax.swing
 * You must change this in every .java file...
 */

import java.lang.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
//import javax.swing.*;
//import javax.swing.border.*;


class Host extends JPanel implements ActionListener
{

    JButton stop,nameToClick;
    JProgressBar info_portscan,info_attack;
	JLabel plugin_tested;
    String cur="0",max="0",phase,curNum;
    private String name;
    private Vector openPorts,holes,infos;
    int holeCount=0,infoCount=0;
    boolean portScanning=true,first=true;
	String[] plugins_order;

    Host(String name,String[] plugins_order)
    {
        super(new FlowLayout(FlowLayout.RIGHT,10,5));

        this.name=name;
		this.plugins_order=plugins_order;

        info_portscan=new JProgressBar();
        info_attack=new JProgressBar();
		stop=new JButton("Stop");
        stop.addActionListener(this);
        nameToClick=new JButton(name);
        nameToClick.setBorder(new EmptyBorder(0,0,0,0));
        nameToClick.addActionListener(this);
		plugin_tested=new JLabel("",JLabel.CENTER);

		JPanel info_panel=new JPanel(new GridLayout(3,2));
		info_panel.add(new JLabel("Portscan : ",JLabel.CENTER));
		info_panel.add(info_portscan);
		info_panel.add(new JLabel("Attack : ",JLabel.CENTER));
		info_panel.add(info_attack);
		info_panel.add(new JLabel("plugin : ",JLabel.CENTER));
		info_panel.add(plugin_tested);

        add("West",nameToClick);
        add("Center",info_panel);
        add("East",stop);
        setBorder(new EtchedBorder());

        openPorts=new Vector();
        holes=new Vector();
        infos=new Vector();
    }

    public String getName()
    {
        return(name);
    }

    public Vector getOpenPorts()
    {
        return(openPorts);
    }

    public Vector getHoles()
    {
        return(holes);
    }

    public Vector getInfos()
    {
        return(infos);
    }

    public void add_open_port(String open)
    {
        openPorts.addElement(open);
    }

    public void addHole(Hole hole)
    {
        holes.addElement(hole);
        holeCount=holeCount+1;
    }

    public void addInfo(Info info)
    {
        infos.addElement(info);
        infoCount=infoCount+1;
    }

    public int getInfoCount()
    {
        return(infoCount);
    }

    public int getHoleCount()
    {
        return(holeCount);
    }

/*    public void setInfo(String current)
    {
        String temp=current.substring(current.indexOf("/")+1,current.length());
        info.setValue(Integer.parseInt(current.substring(0,current.indexOf("/"))));

        if(first)
        {
            curNum=temp;
            first=false;
            info.setMaximum(Integer.parseInt(temp));
            return;
        }

        if(!curNum.equals(temp))
        {
            curNum=temp;
            info.setMaximum(Integer.parseInt(temp));
        }
    }
*/
	public void set_portscan_status(String status)
	{
		int max=Integer.parseInt(status.substring(status.indexOf("/")+1,status.length()));
		int temp=Integer.parseInt(status.substring(0,status.indexOf("/")));

		info_portscan.setMaximum(max);
		info_portscan.setValue(temp);
	}

	public void set_attack_status(String status)
	{
		int max=Integer.parseInt(status.substring(status.indexOf("/")+1,status.length()));
		int temp=Integer.parseInt(status.substring(0,status.indexOf("/")));

		info_attack.setMaximum(max);
		info_attack.setValue(temp);
		plugin_tested.setText(plugins_order[temp-1]);
	}


    public void setPhase(String current)
    {
        phase=current;
    }

    public String getPhase()
    {
        return(phase);
    }

    public boolean isPortScanning()
    {
        return(portScanning);
    }


    public void actionPerformed(ActionEvent evt)
    {
        String command=evt.getActionCommand();

        if(command.equals("Stop"))
        {
            stop.setEnabled(false);
            info_portscan.setForeground(Color.red);
            info_attack.setForeground(Color.red);
            ((Status) getParent().getParent().getParent().getParent().getParent().getParent().getParent().getParent()).stopAttack(this);
        }

        if(command.equals(name))
            ((Status) getParent().getParent().getParent().getParent().getParent().getParent().getParent().getParent()).hostSelected(this);

    }
}

