/* NessusJ 
 * Copyright (C) 1999 Alexis de Bernis <alexisb@cvs.nessus.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This program is a nessusd java client. For any information about
 * the nessus project visit <http://www.nessus.org>
 *
 *      PLEASE READ CAREFULLY NESSUS DOCUMENTATION BEFORE
 *                     USING THIS PROGRAM
 *
 */

/* importation directives has changed in newer JDK, uncomment
 * the ones you use if you have compilation troubles :
 * JDK up to 1.1.7 (Swing 1.0.x) : classes in com.sun.java.swing
 * JDK from 1.2 (Swing 1.1.x) : classes in javax.swing
 * You must change this in every .java file...
 */

import java.awt.event.*;
import java.awt.*;
import java.util.*;
import java.io.*;

import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
import com.sun.java.swing.event.*;
//import javax.swing.*;
//import javax.swing.border.*;
//import javax.swing.event.*;

public class NessusJUI extends JFrame implements WindowListener,ActionListener,ListSelectionListener
{
	private PicsLib pics;
	private NessusJ parent;

	private JTabbedPane tabs;
	private JTextField nessusd_host,nessusd_port,user_login,user_pass,target,max_hosts;
	private JTextField port_range,max_threads,remote_file,user_email,user_rule;
	private JLabel connected_text;
	private JButton login_now,quit,load_report,start_scan,add_user_rule;
	private JButton read_from_file;
	private JCheckBox exp_dns,exp_subnets,exp_nfs,ping_before;
	private JCheckBox reverse_lookup,outside_firewall;
	private JRadioButton scan_normal,scan_heavy,subnet_a,subnet_b,subnet_c;		
	private Box family_list,plugin_list;
	private HomemadeBox port_scanner_list;
	private JList rules_list;
	private Vector rules;
	private Hashtable server_prefs;

	NessusJUI(PicsLib pics,NessusJ parent)
	{
		
		super("NessusJUI");
		this.pics=pics;
		this.parent=parent;
		
		tabs=new JTabbedPane();
		
		nessusd_host=new JTextField(20);
		nessusd_host.setText("localhost");
		nessusd_port=new JTextField(20);
		nessusd_port.setText("3001");
		user_login=new JTextField(20);
		user_pass=new JPasswordField(20);

		login_now=new JButton("Log in now !");
		login_now.addActionListener(this);
		login_now.setActionCommand("login");

		connected_text=new JLabel("");
		quit=new JButton("Quit");
		quit.addActionListener(this);
		quit.setActionCommand("quit_nessusj");
		load_report=new JButton("Load report");
		load_report.addActionListener(this);
		load_report.setActionCommand("load_report");
		start_scan=new JButton("Start the scan");
		start_scan.addActionListener(this);
		start_scan.setActionCommand("start_attack");
		
/* Tab n1: Login */
		JPanel main_login,login_labels,login_textfields,h_rule1,h_rule2;

		main_login=new JPanel(new BorderLayout());
		login_labels=new JPanel(new GridLayout(7,0,20,40));
		login_textfields=new JPanel(new GridLayout(7,0,20,40));
		h_rule1=new JPanel();
		h_rule1.setBorder(new EtchedBorder());
		h_rule2=new JPanel();
		h_rule2.setBorder(new EtchedBorder());
		
		login_labels.add(new JLabel(""));
		login_labels.add(new JLabel("  Nessusd Host : ",pics.get_pic("computer"),JLabel.RIGHT));
		login_labels.add(new JLabel("Port : ",JLabel.RIGHT));	
		login_labels.add(new JLabel("           Login : ",pics.get_pic("user"),JLabel.RIGHT));	
		login_labels.add(new JLabel("Password : ",JLabel.RIGHT));	
		login_labels.add(new JLabel(""));
		login_labels.add(connected_text);
		
		login_textfields.add(new JLabel(""));
		login_textfields.add(nessusd_host);
		login_textfields.add(nessusd_port);
		login_textfields.add(user_login);
		login_textfields.add(user_pass);
		login_textfields.add(new JLabel(""));
		login_textfields.add(login_now);
		
		main_login.setBorder(new TitledBorder("session setup"));
		main_login.add("West",login_labels);
		main_login.add("Center",login_textfields);
		main_login.add("South",Box.createGlue());
		
		tabs.add("Nessusd host",main_login);	

/* Tabs n1 finished */

/* Tabs n2 Target Selection */
		
		JPanel main_target_selection,target_labels,target_comps,target_filler;
		JPanel target_pane;
		ButtonGroup subnet_group;
		
		main_target_selection=new JPanel(new BorderLayout());
		target_labels=new JPanel(new GridLayout(4,0,5,5));
		target_comps=new JPanel(new GridLayout(4,0,5,5));
//		host_expansion=new JPanel(new FlowLayout(FlowLayout.LEFT));
//		subnet_class=new JPanel(new FlowLayout(FlowLayout.LEFT));
		target_filler=new JPanel(new BorderLayout());
		
		target_pane=new JPanel(new BorderLayout());		
		target=new JTextField(20);
		read_from_file=new JButton("Read file...");
		read_from_file.addActionListener(this);
		read_from_file.setActionCommand("read_from_file");
		target_pane.add("Center",target);
		target_pane.add("East",read_from_file);
		max_hosts=new JTextField(20);
		exp_dns=new JCheckBox("Perform a DNS zone transfer");
		exp_dns.setToolTipText("Nessus will perform an AXFR request to obtain the list of the hosts");

//		exp_subnets=new JCheckBox("Subnets");
//		exp_nfs=new JCheckBox("NFS");
//		subnet_group=new ButtonGroup();		
//		subnet_a=new JRadioButton("A");
//		subnet_b=new JRadioButton("B");
//		subnet_c=new JRadioButton("C");
//		subnet_group.add(subnet_a);
//		subnet_group.add(subnet_b);
//		subnet_group.add(subnet_c);

		target_labels.add(new JLabel("Primary target : ",JLabel.RIGHT));
		target_labels.add(new JLabel("Max hosts : ",JLabel.RIGHT));
		target_labels.add(new JLabel("Host expansion : ",JLabel.RIGHT));
//		target_labels.add(new JLabel("Subnet Class : ",JLabel.RIGHT));
		
/*		host_expansion.add(exp_dns);
		host_expansion.add(exp_subnets);
		host_expansion.add(exp_nfs);
*/		
/*		subnet_class.add(subnet_a);
		subnet_class.add(subnet_b);
		subnet_class.add(subnet_c);
*/		
		target_comps.add(target_pane);
		target_comps.add(max_hosts);
		target_comps.add(exp_dns);		
//		target_comps.add(subnet_class);		
		
		main_target_selection.add("West",target_labels);
		main_target_selection.add("Center",target_comps);
		main_target_selection.add("South",Box.createGlue());
		
		target_filler.setBorder(new TitledBorder("Target selection"));
		target_filler.add("North",main_target_selection);
		target_filler.add("Center",Box.createGlue());
		
		tabs.add("Target selection",target_filler);
		tabs.setEnabledAt(1,false);

/* Tabs n2 finished */

/* Tabs n3 Plugins selection */

		JPanel main_plugin_pane;
	    JScrollPane plugins_scrollpane,family_scrollpane;
	    JPanel plugins_fields;
    	Vector plugins;

        main_plugin_pane=new JPanel(new BorderLayout());
        plugin_list=new Box(BoxLayout.Y_AXIS);
        family_list=new Box(BoxLayout.Y_AXIS);
        plugins_scrollpane=new JScrollPane(plugin_list);
        plugins_scrollpane.setBorder(new TitledBorder(new EtchedBorder(),
                                        "Plugins:",
                                        TitledBorder.DEFAULT_JUSTIFICATION,
                                        TitledBorder.DEFAULT_POSITION));
        family_scrollpane=new JScrollPane(family_list);
        family_scrollpane.setBorder(new TitledBorder(new EtchedBorder(),
                                              "Families:",
                                               TitledBorder.DEFAULT_JUSTIFICATION,
                                               TitledBorder.DEFAULT_POSITION));

        plugins_fields=new JPanel(new GridLayout(0,1));
        plugins_fields.add(family_scrollpane);
        plugins_fields.add(plugins_scrollpane);

        main_plugin_pane.add("North",new JLabel("Choose plugins to be tested :"));
        main_plugin_pane.add("Center",plugins_fields);

//        for(int i=0;i<plugins.size();i++)
//            list.add( (PlugIn) plugins.elementAt(i));

        plugin_list.add(Box.createGlue());

		tabs.add("Plugins",main_plugin_pane);
		tabs.setEnabledAt(2,false);

/* Tabs n3 finished */

/* Tabs n4 Scan options */

		JPanel main_scan_options;
		JPanel check_pane,various_pane,port_scanner_pane,top_pane;
//		ButtonGroup scan_level_group;
		JScrollPane port_scanner_scrollpane;

		check_pane=new JPanel(new GridLayout(3,0));
		ping_before=new JCheckBox("Determine if hosts are alive before scanning them",true);
//		ping_before.setToolTipText("Shall the server performs an ICMP ECHO\nrequest before it attacks a host ? (beware :\nsometimes, remote hosts will not answer to\nthose requests. The server needs to be uid\nroot if you selected this option.");
		reverse_lookup=new JCheckBox("Do a reverse lookup on the IP before testing it",true);
//		reverse_lookup.setToolTipText("if this option is set, Nessus will only test the hosts the IP of which have a reverse lookup entry. ie : if the host 192.68.2.1 resolves, we will test it. If it doesn't, it won't be tested. This option is mainly useful when you allow the host expansion option 'subnet'.");
		outside_firewall=new JCheckBox("We are outside a firewall");
//		outside_firewall.setToolTipText("Are the remote host protected by a firewall ? If so and if we are outside the firewall, it is a good idea to turn this option ON, so that Nessus will perform some additional tests to check that the remote firewall is well configured (this option is still experimental).");

		check_pane.add(ping_before);
		check_pane.add(reverse_lookup);
		check_pane.add(outside_firewall);

		various_pane=new JPanel(new GridLayout(3,2));
		various_pane.add(new JLabel("Port range :",JLabel.CENTER));
		port_range=new JTextField();
		various_pane.add(port_range);
		various_pane.add(new JLabel("Max threads :",JLabel.CENTER));
		max_threads=new JTextField();
		various_pane.add(max_threads);
		various_pane.add(new JLabel("Remote file to obtain : ",JLabel.CENTER));
		remote_file=new JTextField();
		various_pane.add(remote_file);

		port_scanner_pane=new JPanel(new BorderLayout());
		port_scanner_list=new HomemadeBox();
//		port_scanner_list.add(Box.createGlue());
		port_scanner_scrollpane=new JScrollPane(port_scanner_list);
		port_scanner_pane.add("North",new JLabel("Port scanner :",JLabel.CENTER));
		port_scanner_pane.add(port_scanner_scrollpane);

		top_pane=new JPanel(new BorderLayout());
		top_pane.add("North",check_pane);
		top_pane.add("Center",various_pane);

		main_scan_options=new JPanel(new BorderLayout());
		main_scan_options.setBorder(new TitledBorder("Scan options"));
		main_scan_options.add("North",top_pane);	
		main_scan_options.add("Center",port_scanner_pane);
	
		tabs.add("Scan options",main_scan_options);
		tabs.setEnabledAt(3,false);

/* Tabs n4 finished */

/* Tabs n5 User */

		JPanel main_user_pane,user_info_pane,user_email_pane,user_rules_pane;
		JScrollPane rules_scrollpane;
		
		user_email=new JTextField(30);
		user_email_pane=new JPanel(new FlowLayout(FlowLayout.LEFT));
		user_email_pane.add(new JLabel("Email : "));
		user_email_pane.add(user_email);
		
		user_rule=new JTextField(25);
		add_user_rule=new JButton("Add rule");
		add_user_rule.addActionListener(this);
		add_user_rule.setActionCommand("add_rule");
		user_rules_pane=new JPanel(new FlowLayout(FlowLayout.LEFT));
		user_rules_pane.add(new JLabel("Rules : "));
		user_rules_pane.add(user_rule);
		user_rules_pane.add(add_user_rule);
		
		user_info_pane=new JPanel(new GridLayout(2,0));
		user_info_pane.add(user_email_pane);
		user_info_pane.add(user_rules_pane);
		
		rules_list=new JList();
		rules_list.addListSelectionListener(this);
		rules_scrollpane=new JScrollPane(rules_list);
		
		main_user_pane=new JPanel(new BorderLayout());
		main_user_pane.add("North",user_info_pane);
		main_user_pane.add("Center",rules_scrollpane);
		main_user_pane.setBorder(new TitledBorder(new EtchedBorder(),
                                 "User",
                                 TitledBorder.DEFAULT_JUSTIFICATION,
                                 TitledBorder.DEFAULT_POSITION));

		tabs.add("User",main_user_pane);
		tabs.setEnabledAt(4,false);

/* Tabs n5 finished */


/* Lower Buttons bar */
		JPanel buttons;
		
		buttons=new JPanel(new FlowLayout());
		buttons.add(start_scan);
		buttons.add(load_report);
		buttons.add(quit);

/* End of lower buttons bar */
		
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add("Center",tabs);
		getContentPane().add("South",buttons);

		pack();
		setSize(450,535);
		addWindowListener(this);

        Dimension screen=Toolkit.getDefaultToolkit().getScreenSize();
        setLocation((screen.width-getSize().width)/2,(screen.height-getSize().height)/2);
		setVisible(true);
	}

    public void windowClosing(WindowEvent evt)
    {
		parent.quit_nessusj();
    }

	public void actionPerformed(ActionEvent evt)
	{
		String command=evt.getActionCommand();

		if(command.equals("login"))
		{
//			System.out.println("NessusJUI :: actionPerformed : login requested");
			
			String host=nessusd_host.getText();
			String user=user_login.getText();
			String pass=user_pass.getText();
			int port=Integer.parseInt(nessusd_port.getText());
			
			if(parent.connect_nessusd(host,port,user,pass)==false)
			{
				System.out.println("NessusJUI :: actionPerformed : error while connecting, aborting.");
				return;
			}
			
			connected_text.setText("Connected");
			login_now.setEnabled(false);						
			tabs.setEnabledAt(1,true);
			tabs.setEnabledAt(2,true);
			tabs.setEnabledAt(3,true);
			tabs.setEnabledAt(4,true);
			tabs.setSelectedIndex(1);
			tabs.setEnabledAt(0,false);
			return;
		}
	
		if(command.equals("start_attack"))
		{
			String host=target.getText();

			if(parent.start_attack(host)==false)
			{
				System.out.println("NessusJUI :: actionPerformed : error while starting the test, aborting.");
				return;
			}
			return;
		}

		if(command.equals("add_rule"))
		{
			if(user_rule.getText().equals(""))
			{
				disp_error_dialog("You must type a rule !");
				return;
			} else
			{
				rules.addElement(new Rule(user_rule.getText()+";",false));
				rules_list.setListData(rules);
				rules_list.repaint();
			}
			return;
		}

		if(command.equals("quit_nessusj"))
		{
			parent.quit_nessusj();
			return;
		}

		if(command.equals("load_report"))
		{
			open_report();
			return;
		}

		if(command.equals("read_from_file"))
		{
			String read=get_string_from_file();
			if(read==null)
				return;
			target.setText(read);
			return;
		}

		System.out.println("NessusJUI :: actionPerformed : action ignored : "+command);
	}

	public void windowClosed(WindowEvent evt ) { }
	public void windowOpened(WindowEvent evt) { }
	public void windowOpening(WindowEvent evt ) { }
	public void windowIconified(WindowEvent evt ) { }
	public void windowActivated(WindowEvent evt ) { }
	public void windowDeiconified(WindowEvent evt ) { }
	public void windowDeactivated(WindowEvent evt ) { }

	public void disp_error_dialog(String msg)
	{
		JOptionPane.showMessageDialog(this,msg,"Error",JOptionPane.ERROR_MESSAGE);
	}

	public void update_family_pane(Hashtable families)
	{

        Enumeration temp=families.elements();

        while(temp.hasMoreElements())
		{
			Family current_family=(Family) temp.nextElement();
            if(current_family.get_family_name().equalsIgnoreCase("Port scanners"))
				refresh_plugin_list(current_family);
			else
				family_list.add(current_family);
		}
	}

    public void refresh_plugin_list(Family to_refresh)
    {
        Enumeration children=to_refresh.getChildren().elements();

		if(to_refresh.get_family_name().equalsIgnoreCase("Port scanners"))
		{
			port_scanner_list.removeAll();

	        while(children.hasMoreElements())
    	        port_scanner_list.addElement((PlugIn) children.nextElement());

//			port_scanner_list.addElement(Box.createGlue());

//			System.out.println("NessusJUI :: refresh_plugin_list : 2nd parent of port_scanner_list is "+port_scanner_list.getParent().getParent().toString());

//	    	((JScrollPane) port_scanner_list.getParent().getParent()).isValidateRoot();
//	    	((JScrollPane) port_scanner_list.getParent().getParent()).validate();
//	    	((JScrollPane) port_scanner_list.getParent().getParent()).repaint();
			
		} else
		{
	        plugin_list.removeAll();

	        while(children.hasMoreElements())
    	        plugin_list.add((PlugIn) children.nextElement());

			plugin_list.add(Box.createGlue());
			
//			tabs.validate();
//			tabs.repaint();


//	    	plugin_list.getParent().isValidateRoot();
//			((JScrollPane) plugin_list.getParent().getParent()).isValidateRoot();
			plugin_list.getParent().getParent().validate();
			plugin_list.getParent().getParent().repaint();
		}
    }

	public void disp_plugin_property(PlugIn plug_to_show)
	{
		new PluginProperties(this,plug_to_show,parent);
	}

	public void update_rules_list(Vector rules)
	{
		rules_list.setListData(rules);
		this.rules=rules;
		rules_list.repaint();
	}

	public void valueChanged(ListSelectionEvent evt)
	{

		if(!rules_list.isSelectedIndex(evt.getFirstIndex()))
			return;		//value was just deselected

		Rule temp=(Rule) rules_list.getSelectedValue();
		
		if(temp.is_server_rule())
		{
			disp_error_dialog("Can't delete this rule : server defined rule.");
		} else
		{
			rules.removeElement(temp);
			rules_list.setListData(rules);
		}
	}	

	public void update_server_prefs(Hashtable server_prefs)
	{
		this.server_prefs=server_prefs;

		max_threads.setText((String) server_prefs_get("max_threads","15"));
		max_hosts.setText((((String) server_prefs_get("max_hosts","-1")).equals("-1"))?"Infinity":((String) server_prefs_get("max_hosts","-1")));
		port_range.setText((String) server_prefs_get("port_range","1-20000"));
		remote_file.setText((String) server_prefs_get("test_file","/etc/passwd"));
		ping_before.setEnabled((((String) server_prefs_get("ping_hosts","yes")).equals("yes"))?true:false);
		user_email.setText((String) server_prefs_get("email","root@localhost"));
		
		String temp=(String) server_prefs_get("host_expansion","dns:nfs");
		if(temp.indexOf("dns")!=-1)
			exp_dns.setSelected(true);
		else
			exp_dns.setSelected(false);		

/*		if(temp.indexOf("ip")!=-1)
			exp_dns.setSelected(true);
		else
			exp_dns.setSelected(false);		*/

/*		if(temp.indexOf("nfs")!=-1)
			exp_nfs.setSelected(true);
		else
			exp_nfs.setSelected(false);		
*/
/*		temp=(String) server_prefs_get("subnet_class","C");
		if(temp.indexOf("A")!=-1)
			subnet_a.setSelected(true);
		if(temp.indexOf("B")!=-1)
			subnet_a.setSelected(true);
		if(temp.indexOf("C")!=-1)
			subnet_a.setSelected(true);
*/
/*		temp=(String) server_prefs_get("scan_level","normal");
		if(temp.equals("normal"))
			scan_normal.setSelected(true);
		else
			scan_heavy.setSelected(true);*/
	}

	public Vector get_rules()
	{
		return(rules);
	}

	public Hashtable get_prefs_to_send(Hashtable server_prefs)
	{
		Hashtable to_send=server_prefs;
		String temp;
		
		to_send.put("email",user_email.getText());
		to_send.put("max_threads",max_threads.getText());
		to_send.put("test_file",remote_file.getText());
		to_send.put("ping_hosts",ping_before.isSelected()?"yes":"no");
		to_send.put("port_range",port_range.getText());
		to_send.put("max_hosts",max_hosts.getText().equals("Infinity")?"-1":max_hosts.getText());
//		to_send.put("scan_level",scan_normal.isSelected()?"normal":"heavy");
		to_send.put("reverse_lookup",reverse_lookup.isSelected()?"yes":"no");
		to_send.put("outside_firewall",outside_firewall.isSelected()?"yes":"no");
		
		temp="ip;";             // IP must be enabled by default
		if(exp_dns.isSelected())
			temp=temp+"dns;";
//		if(exp_subnets.isSelected())
//			temp=temp+"ip;";
//		if(exp_nfs.isSelected())
//			temp=temp+"nfs;";
		if(temp.equals(""))
			temp="none;";
		temp=temp.substring(0,temp.length()-1);
//		System.out.println("NessusJUI :: get_prefs_to_send : host expansion = "+temp);
		to_send.put("host_expansion",temp);
		
/*		if(subnet_a.isSelected())		Obsolete.
			temp="A";
		if(subnet_b.isSelected())
			temp="B";
		if(subnet_c.isSelected())
			temp="C";
		to_send.put("subnet_class",temp); */
		
		Vector plugins=parent.get_plugins();
		temp="";
        for(int i=0;i<plugins.size();i++)
        {
            if(((PlugIn) plugins.elementAt(i)).isActivated())
                temp=temp+((PlugIn) plugins.elementAt(i)).getId()+";";
        }

        if(temp.equals(""))
            temp="0;";

		temp=temp.substring(0,temp.length()-1);
//		System.out.println("NessusJUI :: get_prefs_to_send : plugin_set = "+temp);
		to_send.put("plugin_set",temp);

		return(to_send);
	}

	public String get_host_to_test()
	{
		return(target.getText());
	}


    private void open_report()
    {
        FileDialog dialog=new FileDialog(this,"Open Report...",FileDialog.LOAD);
        String temp,filename,host,type,description,ports;
        String port;
        DataInputStream fromFile;
        Vector hosts=new Vector();

        dialog.setFile("*.nsr");
        dialog.show();

        if((filename=dialog.getFile())==null)
            return;

        try
        {
            fromFile=new DataInputStream(new FileInputStream(filename));
        }catch(FileNotFoundException e)
        {
            disp_error_dialog("Error: file "+filename+" not found");
            return;
        }

        try
        {
            while(fromFile.available()!=0)
            {
                temp=fromFile.readLine();

                host=temp.substring(0,temp.indexOf(" "));
                temp=temp.substring(temp.indexOf(" ")+1);
                Host cur=getHost(host,hosts);
				
				int pos_of_slash=temp.indexOf("/");
				
                try
                {
                    port=temp.substring(0,temp.indexOf(" ",pos_of_slash));

                } catch(Exception e)
                {
                    continue;
                }
                
                temp=temp.substring(temp.indexOf(" ",pos_of_slash)+1);

				if(temp.equals(""))
				{
					markAsOpen(port,cur);

				} else
				{
	                type=temp.substring(0,temp.indexOf(" "));
    	            description=temp.substring(temp.indexOf(" ")+1);
        	        description=description.replace(';','\n');


	                if(type.equals("REPORT"))
    	            {
	                    cur.addHole(new Hole(port,description));
    	                markAsOpen(port,cur);
	                }

    	            if(type.equals("INFO"))
        	        {
            	        cur.addInfo(new Info(port,description));
	                    markAsOpen(port,cur);
    	            }
				}
				cur=null;
            }
        }catch(IOException e)
        {
            disp_error_dialog("Error : impossible to read report");
            return;
        }
        
        new Report(parent, hosts);
    }


/** This useful method will try to return the host corresponding
    to the arg "host" given, if this host doesn't exists, it will
    create a new one and return it.
    @see Host
  */

    public Host getHost(String host,Vector hosts)
    {
        for(int i=0;i<hosts.size();i++)
        {
            if(((Host) hosts.elementAt(i)).getName().equals(host))
                return((Host) hosts.elementAt(i));
        }

//*        System.out.println("Unknown machine : "+host+". Creating...");
        Host temp=new Host(host,null);
        hosts.addElement(temp);
        return(temp);
    }


/** This method mark a port as open on a given host (fixes a 
  * bug in report display). */

    private void markAsOpen(String port,Host host)
    {
        Vector openPorts=host.getOpenPorts();

        for(int i=0;i<openPorts.size();i++)
        {
            if(((String) openPorts.elementAt(i)).equals(port))
                return;
        }

        host.add_open_port(port);
    }


/** This function return a server-defined preferences or
  * a default value specified bye the caller if the
  * preference has not been specified by the server.
  * This corrects a bug in a devel version (thanks to
  * Renaud Deraison <deraison@nessus.org>). */

	private String server_prefs_get(String name,String notdef)
	{
		String res=(String) server_prefs.get(name);

		return((name==null)?notdef:res);
	}

	private String get_string_from_file()
	{
        FileDialog dialog=new FileDialog(this,"Open File...",FileDialog.LOAD);
        String temp,filename,res;
        DataInputStream fromFile;

        dialog.setFile("*");
        dialog.show();

        if((filename=dialog.getFile())==null)
            return(null);

		filename=dialog.getDirectory()+filename;

        try
        {
            fromFile=new DataInputStream(new FileInputStream(filename));
        }catch(FileNotFoundException e)
        {
            disp_error_dialog("NessusJUI :: get_string_from_file : file "+filename+" not found");
            return(null);
        }

        try
        {
			res="";
			
            while(fromFile.available()!=0)
            {
                temp=fromFile.readLine();
				res=res+","+temp;
			}

		} catch(IOException e)
		{
			System.out.println("NessusJUI :: get_string_from_file : Error reading from file "+filename);
			System.out.println(e);
			return(null);
		}

		return(res.substring(1));
	}
}
