/* NessusJ
 * Copyright (C) 1999 Alexis de Bernis <alexisb@cvs.nessus.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This program is a nessusd java client. For any information about
 * the nessus project visit <http://www.nessus.org>
 *
 *      PLEASE READ CAREFULLY NESSUS DOCUMENTATION BEFORE
 *                     USING THIS PROGRAM
 *
 */

/* importation directives has changed in newer JDK, uncomment
 * the ones you use if you have compilation troubles :
 * JDK up to 1.1.7 (Swing 1.0.x) : classes in com.sun.java.swing
 * JDK from 1.2 (Swing 1.1.x) : classes in javax.swing
 * You must change this in every .java file...
 */

import java.lang.*;
import java.util.*;

import com.sun.java.swing.*;
//import javax.swing.*;

public class PicsLib extends Hashtable
{
	Hashtable pics_name;


	PicsLib(boolean load_all)
	{
		super();

//		System.out.println("======== Initializing PicsLib ========");

//		System.out.print("Making pics_name...");
		pics_name=mk_pics_name_table();
//		System.out.println("ok");
	
		if(load_all==true)
		{
//			System.out.println("Loading all pics...");
			
			Enumeration names=pics_name.keys();
			while(names.hasMoreElements())
				put(names.nextElement(),load_pic((String) pics_name.get(names.nextElement())));			
		}

//		System.out.println("======== PicsLib initialized =========");
	}


	private Hashtable mk_pics_name_table()
	{
		Hashtable res=new Hashtable();
		
		res.put("nessusj","NessusJ.gif");
		res.put("attack","attack.gif");
		res.put("denial","bomb.gif");
		res.put("computer","computer.gif");
		res.put("connected","connected.gif");
		res.put("infos","info.gif");
		res.put("flag_green","l_green.gif");
		res.put("flag_orange","l_orange.gif");
		res.put("flag_red","l_red.gif");
		res.put("user","user.gif");
		res.put("scanner","connected.gif");
		res.put("have_prefs","HandOpen.gif");	

		return(res);
	}

	public ImageIcon get_pic(String name)
	{
		ImageIcon pic=(ImageIcon) get(name);
		
//		System.out.print("PicsLib :: get_pic : looking for "+name+"...");
		
		if(pic==null)
		{
//			System.out.println("loading");
			put(name,load_pic((String) pics_name.get(name)));
			return((ImageIcon) get(name));
		}

//		System.out.println("already loaded");
		return(pic);
	}

	public void unload_pic(String name)
	{
		if(get(name)==null)
			return;
		
		remove(name);
	}
	
	private ImageIcon load_pic(String path)
	{
//		System.out.println("PicsLib :: load_pic : loading "+path);
		return(new ImageIcon(path));
	}
}
