/* NessusJ
 * Copyright (C) 1999 Alexis de Bernis <alexisb@cvs.nessus.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This program is a nessusd java client. For any information about
 * the nessus project visit <http://www.nessus.org>
 *
 *      PLEASE READ CAREFULLY NESSUS DOCUMENTATION BEFORE
 *                     USING THIS PROGRAM
 *
 */

/* importation directives has changed in newer JDK, uncomment
 * the ones you use if you have compilation troubles :
 * JDK up to 1.1.7 (Swing 1.0.x) : classes in com.sun.java.swing
 * JDK from 1.2 (Swing 1.1.x) : classes in javax.swing
 * You must change this in every .java file...
 */

import java.lang.*;
import java.awt.*;
import java.util.Vector;
import java.awt.event.*;

import com.sun.java.swing.*;
//import javax.swing.*;

class PluginProperties extends JDialog implements ActionListener
{
    JPanel header,top,text;
    JButton close;
    JTextArea description;
    JLabel icon;
    PlugIn plugin;
	PicsLib pics;
	NessusJ parent;

    PluginProperties(JFrame parent, PlugIn plugin,NessusJ main_parent)
    {
        super(parent,"Plugin properties",true);

        this.plugin=plugin;
		this.parent=main_parent;
		this.pics=main_parent.get_pics_lib();

		icon=new JLabel(pics.get_pic(plugin.getType()));
		
        setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
        header=new JPanel(new BorderLayout());
        top=new JPanel(new BorderLayout());
        close=new JButton("Close");
        close.addActionListener(this);
        description=new JTextArea(10,20);
        description.setLineWrap(true);
        description.setWrapStyleWord(true);
        text=new JPanel(new GridLayout(2,0));

        text.add(new JLabel(plugin.getName(),JLabel.CENTER));
        text.add(new JLabel(plugin.getCopyright(),JLabel.CENTER));

        top.add("Center",text);
        top.add("South",new HRule(350,1,0,1));
        top.add("West",icon);

        header.add("Center",top);
        header.add("South",new JLabel("Family : "+plugin.getFamily()));

        getContentPane().add("North",header);
        getContentPane().add("Center",description);
        getContentPane().add("South",close);

        description.append(plugin.getDescription());

        pack();

        Dimension screen=Toolkit.getDefaultToolkit().getScreenSize();
        setLocation((screen.width-getSize().width)/2,(screen.height-getSize().height)/2);
        setVisible(true);

    }
    
    public void actionPerformed(ActionEvent evt)
    {
        String command=evt.getActionCommand();

        if(command.equals("Close"))
            dispose();
    }
}
