/* NessusJ
 * Copyright (C) 1999 Alexis de Bernis <alexisb@cvs.nessus.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This program is a nessusd java client. For any information about
 * the nessus project visit <http://www.nessus.org>
 *
 *      PLEASE READ CAREFULLY NESSUS DOCUMENTATION BEFORE
 *                     USING THIS PROGRAM
 *
 */

/* importation directives has changed in newer JDK, uncomment
 * the ones you use if you have compilation troubles :
 * JDK up to 1.1.7 (Swing 1.0.x) : classes in com.sun.java.swing
 * JDK from 1.2 (Swing 1.1.x) : classes in javax.swing
 * You must change this in every .java file...
 */

import java.lang.*;
import java.io.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;

import com.sun.java.swing.*;
//import javax.swing.*;


class Status extends JFrame implements ActionListener
{
    JScrollPane pane;
    JPanel infos;
    Box list;
    JButton stopAll;
    JPanel button,main;
    Vector hosts;
    Listener listener;
    NessusJ parent;
    Report report;
    JLabel curHost,numHoles,numInfos,curPlugin;
    String plugins_order[];
    DataOutputStream for_nessusd;


    Status(NessusJ parent,DataInputStream from_nessusd,DataOutputStream for_nessusd,String machine,String plugins_order[])
    {
        super("Attack status");

        this.parent=parent;
        this.plugins_order=plugins_order;
		this.for_nessusd=for_nessusd;

        getContentPane().setLayout(new BorderLayout());

        list=new Box(BoxLayout.Y_AXIS);
        pane=new JScrollPane(list);

        stopAll=new JButton("Stop All!");

        button=new JPanel(new FlowLayout());
        button.add(stopAll);

        curHost=new JLabel("No host selected");
        numHoles=new JLabel("---");
        numInfos=new JLabel("---");

        infos=new JPanel(new GridLayout(0,2));
        infos.add(new JLabel("Host :"));
        infos.add(curHost);
        infos.add(new JLabel("Holes already founds :"));
        infos.add(numHoles);
        infos.add(new JLabel("Infos already founds :"));
        infos.add(numInfos);

        main=new JPanel(new BorderLayout());
        main.add("Center",pane);
        main.add("South",infos);

        getContentPane().add("Center",main);
        getContentPane().add("South",button);

        hosts=new Vector();
        Host temp;
		
		if(machine.indexOf("/")==-1)
		{
			if(machine.indexOf(",")==-1)			
				temp=new Host(machine,plugins_order);
			else
				temp=new Host(machine.substring(0,machine.indexOf(",")-1),plugins_order);
		}
		else
		{
			if(machine.indexOf(",")==-1)			
				temp=new Host(machine.substring(0,machine.indexOf("/")-1),plugins_order);
			else
			{
				if(machine.indexOf("/")<machine.indexOf(","))
					temp=new Host(machine.substring(0,machine.indexOf("/")-1),plugins_order);
				else
					temp=new Host(machine.substring(0,machine.indexOf(",")-1),plugins_order);
			}
		}

        hosts.addElement(temp);
        list.add(temp);
//        list.add(Box.createGlue());

        pack();
        Dimension size=getSize();
        setSize(new Dimension(size.width,450));
        setLocation(10,100);
        setVisible(true);
        report=new Report(parent,hosts);
        listener=new Listener(this, from_nessusd, for_nessusd);
        listener.start();
    }

    public void jobFinished()
    {
        dispose();
//        new NessusdReport(this,hosts);
    }

    public void post_port(String victim,String port)
    {
        Host host=getHost(victim);
        host.add_open_port(port);

        if(report.getCurrentHost().equals(victim))
            report.refreshPort();
    }

    public void refresh_host(String victim,String phase,String cur)
    {
        Host host=getHost(victim);

		if(phase.equals("portscan"))
	        host.set_portscan_status(cur);
		else
			host.set_attack_status(cur);
    }

    public void post_hole(String victim, Hole hole)
    {
        Host host=getHost(victim);
        host.addHole(hole);
        markAsOpen(hole.getPort(),host);
        if(host.getName().equals(curHost.getText()))
            numHoles.setText(String.valueOf(host.getHoleCount()));

        report.refreshHosts();

        if(report.getCurrentHost().equals(victim))
            report.refreshPort();

        if(report.getCurrentHost().equals(victim) &&
           report.getCurrentPort().equals(hole.getPort()))
           report.refreshDescription(hole.getPort());

    }

    public void post_info(String victim, Info info)
    {
        Host host=getHost(victim);
        host.addInfo(info);
        markAsOpen(info.getPort(),host);
        if(host.getName().equals(curHost.getText()))
            numInfos.setText(String.valueOf(host.getInfoCount()));

        report.refreshHosts();

        if(report.getCurrentHost().equals(victim))
            report.refreshPort();

        if(report.getCurrentHost().equals(victim) &&
           report.getCurrentPort().equals(info.getPort()))
           report.refreshDescription(info.getPort());
    }


    public Host getHost(String host)
    {
        for(int i=0;i<hosts.size();i++)
        {
            if(((Host) hosts.elementAt(i)).getName().equals(host))
                return((Host) hosts.elementAt(i));
        }

//*        System.out.println("Unknown machine : "+host+". Creating...");
        Host temp=new Host(host,plugins_order);
        hosts.addElement(temp);
        list.add(temp);
        pack();

        report.refreshHosts();

        return(temp);
    }

    private void markAsOpen(String port,Host host)
    {
        Vector openPorts=host.getOpenPorts();

        for(int i=0;i<openPorts.size();i++)
        {
            if(((String) openPorts.elementAt(i)).equals(port))
                return;
        }

        host.add_open_port(port);
    }

    public void stopAttack(Host host)
    {
        String separator=" <|> ";
        String entity="CLIENT";

        String message=entity+separator+
                       "STOP_ATTACK"+separator+
                       host.getName()+separator+
                       entity+"\n";

		sendln(message);
    }

    private void stopAllAttacks()
    {
        for(int i=0;i<hosts.size();i++)
            stopAttack((Host) hosts.elementAt(i));
    }



    public void back()
    {
        dispose();
    }

    public void actionPerformed(ActionEvent evt)
    {
        String command=evt.getActionCommand();

        if(command.equals("Stop All!"))
            stopAllAttacks();
    }

    public void hostSelected(Host source)
    {
        curHost.setText(source.getName());
        numHoles.setText(String.valueOf(source.getHoleCount()));
        numInfos.setText(String.valueOf(source.getInfoCount()));
    }

	public boolean sendln(String msg)
	{
		try
		{
			for_nessusd.writeBytes(msg+"\n");
		} catch(Exception e)
		{
			System.out.println("Status :: sendln : error sending "+msg);
			return(false);
		}
		return(true);
	}
}
